#!/usr/bin/perl -w -I.
use strict;

#  ----------------------------------------------------------------------
# | Open Archives Initiative Harvesting Framework version 1.1            |
# | Hussein Suleman                                                      |
# | September 2001                                                       |
#  ----------------------------------------------------------------------
# |  Virginia Polytechnic Institute and State University                 |
# |  Department of Computer Science                                      |
# |  Digital Library Research Laboratory                                 |
#  ----------------------------------------------------------------------

# Installation :
#   copy all file into a directory from which you can execute scripts
#
# Testing :
#   use the repository explorer (http://purl.org/net/oai_explorer)
#   to test your interface

package Parameter;

sub new
{
   my ($classname) = shift;
   my $self = {};

   my (@parray, $i);
   $self->{'qstring'} = defined $ENV{'QUERY_STRING'} ? $ENV{'QUERY_STRING'} : '';
   if ($self->{'qstring'} eq '')
   { $self->{'qstring'} = <STDIN>; }
   if (! defined $self->{'qstring'}) { $self->{'qstring'} = ''; }
   @parray=split (/[=&]/, $self->{'qstring'});
   for ( $i=0; $i<=$#parray; $i++ )
   {
      $parray[$i] =~ s/\+/ /g;
      $parray[$i] =~ s/\n//g;
      $parray[$i] =~ s/%[0-9A-F][0-9A-F]/sprintf("%c", hex (substr ($&, 1)))/ge;
      while (substr ($parray[$i], 0, 1) eq ' ')
      { $parray[$i] = substr ($parray[$i], 1); }
      while ((substr ($parray[$i], length ($parray[$i])-1, 1) eq ' ') || 
             (substr ($parray[$i], length ($parray[$i])-1, 1) eq "\r") ||
             (substr ($parray[$i], length ($parray[$i])-1, 1) eq "\n"))
      { chop $parray[$i]; }
   }
   for ( $i=0; $i<=$#parray; $i+=2 )
   {
      $self->{$parray[$i]} = $parray[$i+1];
   }
   my $server_name = defined $ENV{'SERVER_NAME'} ? $ENV{'SERVER_NAME'} : 'servername';
   my $script_name = defined $ENV{'SCRIPT_NAME'} ? $ENV{'SCRIPT_NAME'} : 'scriptname';
   my $server_port = defined $ENV{'SERVER_PORT'} ? $ENV{'SERVER_PORT'} : 'serverport';
   $self->{'baseURL'} = "http://$server_name:".$server_port.$script_name;
   $self->{'requestURL'} = "$self->{'baseURL'}?$self->{'qstring'}";

   bless $self, $classname;
   return $self;
}

1;
